﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'Class module
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: Description Info
Sub Class_Globals
	Type StackClass (Record As List, RecordTop As Long)
	Private StackData As StackClass
End Sub

Public Sub Initialize
	StackData.Initialize 
	StackData.RecordTop=0 
	StackData.Record.Initialize
End Sub

Public Sub Push(objData As Object)
	StackData.RecordTop=StackData.RecordTop+1
	If StackData.Record.Size>StackData.RecordTop Then
		StackData.Record.Set(StackData.RecordTop,objData)
	Else
		StackData.Record.Add(objData)
	End If
End Sub 

Public Sub Pop() As Object 
	If StackData.RecordTop>0 Then 
		Dim objData As Object 
		objData = StackData.Record.Get(StackData.RecordTop-1)
		StackData.Record.RemoveAt(StackData.RecordTop-1)
		StackData.RecordTop=StackData.RecordTop-1
		Return objData
	Else
		Return Null
	End If
End Sub 

Public Sub Peek() As Object
	If StackData.RecordTop>0 Then 
		Dim objData As Object 
		objData = StackData.Record.Get(StackData.RecordTop-1)
		Return objData
	Else
		Return Null
	End If
End Sub

Public Sub Count() As Long
	Return StackData.Record.Size
End Sub

Public Sub ClearAll As Boolean 
	StackData.RecordTop=0
	StackData.Record.Clear
	Return True
End Sub 