﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
Sub Process_Globals
	Private parent As String
	Dim clas As String
	Dim id As String
	Public myStack As StackFile
	Dim sb As StringBuilder
	Dim pat As String ="(\d+)\s(\S*)\s?(.*)"
	Dim pat1 As String ="@\D+(\d+)@"
	Dim level As Int
	Type record(c1 As Int, c2, c3, parent, clas As String)
	Private id_name, id_ev, id_c, id_p As Int
End Sub

Sub ReadFile(FilePath As String,FileName As String)
	id_ev=0: id_c=0: id_p=0
	Dim c1, ecount As Int, c2, c3 As String
	Dim isconc As Boolean
	myStack.Initialize
	Try
		Dim rd As TextReader
		rd.Initialize(File.OpenInput(FilePath, FileName))
		Dim strLines As String= rd.ReadLine
		Dim r As record
		r.Initialize
		Do While strLines <> Null
			ecount=ecount+1
			Dim sb As StringBuilder: sb.Initialize
			Dim m As Matcher = Regex.Matcher(pat,strLines)
			
			Do While m.Find
				c1=m.Group(1): c2=m.Group(2): c3=m.Group(3)
			Loop
			Select Case c2
				Case "CONC"
					r.c3=sb.Append(r.c3).Append(c3)
					strLines = rd.ReadLine
				Case "CONT"
					r.c3=sb.Append(r.c3).Append(CRLF).Append(c3)
					strLines = rd.ReadLine
				Case Else
					If isconc Then
						FillDB(r)
					End If
					r.c1=c1: r.c2=c2: r.c3=c3
					isconc=True
					strLines = rd.ReadLine
			End Select
		Loop
	Catch
		Log(LastException)
		'нужно перейти в настройки и отменить открытие последнего файла
	End Try
	rd.Close
	myStack.ClearAll
End Sub

Sub FillDB(r As record)
If r.c1=0 Then
		If r.c3="" Then
			clas="HEAD"
		Else
			If r.c3.Length>=4 Then
				If r.c3.SubString2(0,4)="NOTE" Then
					clas="NOTE"
					r.c3=r.c3.SubString(4).Trim
				Else
					clas=r.c3
				End If
			Else
				clas=r.c3
			End If
		End If
		myStack.Push(r.c2)
	Else
		If r.c1>level Then
			parent=myStack.Peek
			myStack.Push(r.c2)
		Else If	r.c1<level Then
			For j=0 To level-r.c1
				myStack.Pop
			Next
			parent=myStack.Peek
			myStack.Push(r.c2)
		Else
			myStack.Pop
			parent=myStack.Peek
			myStack.Push(r.c2)
		End If
	End If
	r.parent=parent: r.clas=clas: level=r.c1
	Select Case r.clas
		Case "HEAD"
			Main.db.ExecNonQuery("INSERT INTO header (c1,c2,c3,parent) VALUES ('" & r.c1 & "','" & r.c2 & "','" & r.c3 & "','" & r.parent & "')")
			If r.c1=0 Then
'				db.head.sour.Initialize
'				db.head.date.Initialize,
'				db.head.gedc.Initialize
'				db.head.sour.corp.Initialize
			Else
'				SetHeader(r)
			End If
		Case "SUBM"
			If r.c1 = 0 Then
				DBUtils.InsortId(Main.db, "submitter", "id", r.c2)
			Else
				SetSubmitter(r)
			End If
		Case "INDI"
			If r.c1 = 0 Then
				id_p=id_p+1
				id=r.c2
				Main.db.ExecNonQuery("INSERT INTO persons (id,key) VALUES ('" & id & "'," & id_p &")")
			Else
				SetPerson(r)
			End If
		Case "FAM"
			If r.c1 = 0 Then
				id=r.c2
				DBUtils.InsortId(Main.db, "families", "id", id)
			Else
				SetFamily(r)
			End If
		Case "NOTE"
			If r.c1 = 0 Then
				id=r.c2
				Main.db.ExecNonQuery("INSERT INTO notes (id, txt) VALUES ('" & id & "', '" & r.c3 & "')")
			End If
		Case "OBJE"
			If r.c1 = 0 Then
				id=r.c2
				DBUtils.InsortId(Main.db, "media", "id", id)
			Else
				SetMedia(r)
			End If
		Case "REPO"
			If r.c1 = 0 Then
				id=r.c2
				DBUtils.InsortId(Main.db, "repositories", "id", id)
			Else
'				SetRepo(r)
			End If
		Case "SOUR"
			If r.c1 = 0 Then
				id=r.c2
				DBUtils.InsortId(Main.db, "sources", "id", id)
			Else
'				SetSource(r)
			End If
		Case "_LOC"
'			setLocation(r)
	End Select
End Sub

Sub SetPerson(r As record)
	parent=r.parent
	Select Case r.c1
		Case "1"
			Select Case r.c2
				Case "NAME"
					Main.db.ExecNonQuery("INSERT INTO names (id_p, p_name) VALUES ('" & id & "', '" & r.c3 & "')")
					id_name=id_name+1
				Case "SEX"
					DBUtils.UpdateField(Main.db, "persons", "sex", r.c3, id)
				Case "FAMC"
'					Dim fc As ClassFamChild
'					fc.fam=r.c3
'					person.famc.Add(fc)
				Case "FAMS"
'					person.fams.Add(r.c3)
					Main.db.ExecNonQuery("INSERT INTO persons_fams (foreign_id, id_fams) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "NOTE"
					Main.db.ExecNonQuery("INSERT INTO persons_notes (foreign_id, id_n) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "SOUR"
					SetCitation("persons_citat", id, r)
				Case "OBJE"
					Main.db.ExecNonQuery("INSERT INTO persons_media (foreign_id, id_m) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "ADOP", "BAPM", "BARM", "BASM", "BIRT", "BLES", "BURI", "CAST", "CAUS", "CHAN", _
		             "CENS", "CHR", "CHRA", "CONF", "CREM", "DEAT", "DSCR", "EDUC", "EMIG", _
		             "EVEN", "FCOM", "GRAD", "IDNO", "IMMI", "NATI", "NATU", "NCHI", "NMR", "OCCU", _
		             "ORDN", "PROB", "PROP", "RELI", "RESI", "RETI", "SSN ", "TITL", "WILL"
					id_ev=getKeyEv
					Main.db.ExecNonQuery("INSERT INTO events (id, even, data) VALUES ('" & id_ev & "', '" & r.c2 & "', '" & r.c3 & "')")
					Main.db.ExecNonQuery("INSERT INTO persons_events (foreign_id, id_e) VALUES ('" & id & "', '" & id_ev & "')")
				Case "_UID","_LOC"
				Case Else
'					setList(r)
			End Select
		Case Else
			Select Case r.c2
'				Case "GIVN", "SURN", "PEDI", "CHAN", "TIME"
				Case "PEDI"
'					Dim fc As ClassFamChild=person.famc.Get(person.famc.Size-1)
'					fc.pedi=r.c3.ToLowerCase
'				Case "NOTE"
					
'				Case "OBJC"
				Case Else
					Select parent
						Case "NAME"
							Select Case r.c2
								Case "GIVN"
									DBUtils.UpdateField(Main.db, "names", "givn", r.c3, id_name)
								Case "SURN"
									DBUtils.UpdateField(Main.db, "names", "surn", r.c3, id_name)
								Case "TYPE"
									DBUtils.UpdateField(Main.db, "names", "type", r.c3, id_name)
								Case "NOTE"
									Main.db.ExecNonQuery("INSERT INTO names_notes (foreign_id, id_n) VALUES ('" & id_name & "', '" & r.c3 & "')")
								Case "SOUR"
									Main.db.ExecNonQuery("INSERT INTO names_citat (foreign_id, id_c) VALUES ('" & id_name & "', '" & r.c3 & "')")
							End Select
						Case "SOUR"
'							DBUtils.UpdateField(Main.db, "citations", "notes", r.c3, id_c)
						Case Else
							SetEvent(r)
					End Select
'					SetEvent(r)
			End Select
	End Select
End Sub

Sub getKeyEv As Int
	id_ev=id_ev+1
	Return id_ev
End Sub

Sub getKeyCit As Int
	id_c=id_c+1: Return id_c
End Sub

Sub SetFamily(r As record)
	parent=r.parent
'	family=db.family.Get(id)
	Select Case r.c1
		Case "1"
			Select Case r.c2
				Case "ANUL", "CENS", "CHAN", "DIV", "DIVF", "ENGA", "EVEN", "MARB", "MARC", "MARR", "MARL", "MARS", "RESI"
					id_ev=getKeyEv
					Main.db.ExecNonQuery("INSERT INTO events (id, even) VALUES ('" & id_ev & "', '" & r.c2 & "')")
					Main.db.ExecNonQuery("INSERT INTO families_events (foreign_id, id_e) VALUES ('" & id & "', '" & id_ev & "')")
				Case "HUSB"
					DBUtils.UpdateField(Main.db, "families", "husb", r.c3, id)
				Case "WIFE"
					DBUtils.UpdateField(Main.db, "families", "wife", r.c3, id)
				Case "CHIL"
					Main.db.ExecNonQuery("INSERT INTO families_child (foreign_id, id_c) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "OBJE"
					Main.db.ExecNonQuery("INSERT INTO families_media (foreign_id, id_m) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "NOTE"
					Main.db.ExecNonQuery("INSERT INTO families_notes (foreign_id, id_n) VALUES ('" & id & "', '" & r.c3 & "')")
				Case "SOUR"
					Main.db.ExecNonQuery("INSERT INTO families_citat (foreign_id, id_c) VALUES ('" & id & "', '" & r.c3 & "')")
				Case Else
'					setList(r)
			End Select
		Case Else
			Select Case parent
				Case "_ASSO", "_WTN"
'					Dim w As witnes=event.witness.Get(event.witness.Size-1)
'					w.typew=r.c3
			End Select
			SetEvent(r)
	End Select
End Sub

Sub SetEvent(r As record)
	Select Case r.c2
		Case "TYPE"
			Select Case parent
				Case "EVEN"
					DBUtils.UpdateField(Main.db, "events", "types", r.c3, id_ev)
'				Case "NAME"

				Case Else
					DBUtils.UpdateField(Main.db, "events", "data", r.c3, id_ev)
			End Select
		Case "ADOP"
'			event.fampar.parent=r.c3
		Case "FAMC"
'			event.fampar.fam=r.c3
		Case "ADDR"
'			event.address.addressline=r.c3
		Case "RESN"
			DBUtils.UpdateField(Main.db, "events", "restriction", r.c3, id_ev)
		Case "PLAC", "MAP", "LATI", "LONG", "_LOC"
'			setPlace(r)
		Case "AGNC"
			DBUtils.UpdateField(Main.db, "events", "agen", r.c3, id_ev)
		Case "DATE"
			If parent="DATA" Then
				DBUtils.UpdateField(Main.db, "citations", "date", r.c3, id_c)
'				Dim n As Int=Main.db.ExecQuerySingleResult ("Select count(*) FROM citdata WHERE id=" & id_c)
'				If n=0 Then
'					Main.db.ExecNonQuery("INSERT INTO citdata (id,date) VALUES ('" & id_c & "', '" & r.c3 & "')")
'				Else
'					DBUtils.UpdateField(Main.db, "citdata", "date", r.c3, id_c)
'				End If
			Else
				DBUtils.UpdateField(Main.db, "events", "date", r.c3, id_ev)
			End If
		Case "CAUS"
			DBUtils.UpdateField(Main.db, "events", "cause", r.c3, id_ev)
		Case "_WTN", "_ASSO"
'			Dim w As witnes
'			w.Initialize
'			w.foreign_iderson=r.c3
'			event.witness.Add(w)
		Case "NOTE"
			Select Case parent
				Case "SOUR"
					Main.db.ExecNonQuery("INSERT INTO citations_notes (foreign_id, id_n) VALUES ('" & id_c & "', '" & r.c3 & "')")
				Case "OBJE"
'					SetNote(media.notes,r.c3)
				Case "PLAC"
'					setPlace(r)
				Case Else
					Main.db.ExecNonQuery("INSERT INTO events_notes (foreign_id, id_n) VALUES ('" & id_ev & "', '" & r.c3 & "')")
			End Select
		Case "OBJE"
			Select Case parent
				Case "PLAC"
'					setPlace(r)
				Case "SOUR"
					Main.db.ExecNonQuery("INSERT INTO citations_media (foreign_id, id_m) VALUES ('" & id_c & "', '" & r.c3 & "')")
				Case Else
					Main.db.ExecNonQuery("INSERT INTO events_media (foreign_id, id_m) VALUES ('" & id_ev & "', '" & r.c3 & "')")
			End Select
					
		Case "TITL","FILE","FORM"
			SetMedia(r)				'2
		Case "PAGE"
			DBUtils.UpdateField(Main.db, "citations", "page", r.c3, id_c)
		Case "QUAY"
			DBUtils.UpdateField(Main.db, "citations", "quay", r.c3, id_c)
		Case "EVEN"
			If r.c3<>"" Then
				DBUtils.UpdateField(Main.db, "citations", "even", r.c3, id_c)
			End If
		Case "ROLE"
			Select Case parent
				Case "EVEN"
					If r.c3<>"" Then
						DBUtils.UpdateField(Main.db, "citations", "role", r.c3, id_c)
					End If
				Case "_WTN", "_ASSO"
'					Dim w As witnes=event.witness.Get(event.witness.Size-1)
'					w.typew=r.c3
			End Select
		Case "SOUR" ' для событий
			Select Case parent
				Case "NAME"
'					SetCitation("names_citat",r)
				Case "PLAC"
'					setPlace(r)
				Case Else
					SetCitation("events_citat", id_ev, r)
			End Select
		Case "TEXT"
			If parent="DATA" Then
				If r.c3<>"" Then
					DBUtils.UpdateField(Main.db, "citations", "text", r.c3, id_c)
				End If
			End If
		Case "NICK"
'			function.lodError(r)
		Case "RELA"
'			Dim w As witnes=event.witness.Get(event.witness.Size-1)
'			w.typew=r.c3
'		Case "GIVN", "SURN", "PEDI", "CHAN", "TIME"

		Case Else
'			setList(r)c
	End Select
End Sub

Sub SetHeader(r As record)
	parent=r.parent
	Select Case r.c2
		Case "ADDR"
'			Main.db.head.sour.corp.adr=r.c3
		Case "CHAR"
			If r.c3<>"UTF-8" Then
'				MsgboxAsync(Starter.loc.Localize("Кодировка файла, указанная в теге CHAR, должна быть UTF-8"),"")
			End If
'			db.head.charac=r.c3
		Case "CORP"
'			db.head.sour.corp.corp=r.c3
		Case "DATE"
'			db.head.date.date=r.c3
		Case "DEST"
'			db.head.dest=r.c3
		Case "FILE"
'			db.head.gedfile=r.c3
		Case "FORM"
'			db.head.gedc.form=r.c3
		Case "GEDC"

		Case "NAME"
'			db.head.sour.name=r.c3
		Case "SOUR"
'			db.head.sour.sour=r.c3
		Case "SUBM"
'			db.head.subm=r.c3
		Case "TIME"
'			db.head.date.time=r.c3
		Case "VERS"
			If parent="SOUR" Then
'				db.head.sour.vers=r.c3
			Else
'				db.head.gedc.vers=r.c3
			End If
		Case "WWW"
'			db.head.sour.corp.www=r.c3
		Case "_HOME"
'			db.head.home=r.c3
	End Select
End Sub

Sub SetSubmitter(r As record)
	parent=r.parent
	Select Case r.c2
		Case "NAME"
			DBUtils.UpdateField(Main.db, "submitter", "name", r.c3, "@SUBM@")
		Case "ADDR"
			DBUtils.UpdateField(Main.db, "submitter", "addr", r.c3, "@SUBM@")
		Case "PHON"
			DBUtils.UpdateField(Main.db, "submitter", "phon", r.c3, "@SUBM@")
		Case "FAX"
			DBUtils.UpdateField(Main.db, "submitter", "fax", r.c3, "@SUBM@")
		Case "EMAIL"
			DBUtils.UpdateField(Main.db, "submitter", "email", r.c3, "@SUBM@")
		Case "WWW"
			DBUtils.UpdateField(Main.db, "submitter", "www", r.c3, "@SUBM@")
	End Select
End Sub

Sub SetMedia(r As record)
	Select Case r.c2
		Case "FILE"
			DBUtils.UpdateField(Main.db, "media", "file", r.c3, id)
		Case "FORM"
			DBUtils.UpdateField(Main.db, "media", "form", r.c3, id)
		Case "TITL"
			DBUtils.UpdateField(Main.db, "media", "titl", r.c3, id)
	End Select
End Sub

Sub SetCitation(tblName As String,id_key,r As record)
	id_c=getKeyCit
	Main.db.ExecNonQuery("INSERT INTO citations (id, source) VALUES ('" & id_c & "', '" & r.c3 & "')")
	Main.db.ExecNonQuery("INSERT INTO " & tblName & " (foreign_id, id_c) VALUES ('" & id_key & "', '" & id_c & "')")
End Sub